var turnplate={
    restaraunts:[],				//大转盘奖品名称
    colors:[],					//大转盘奖品区块对应背景颜色
    outsideRadius:155,			//大转盘外圆的半径
    textRadius:142,				//大转盘奖品位置距离圆心的距离
    insideRadius:40,			//大转盘内圆的半径
    startAngle:0,				//开始角度

    bRotate:false				//false:停止;ture:旋转
};

$(document).ready(function(){
    //动态添加大转盘的奖品与奖品区域背景颜色
    turnplate.restaraunts = ["50元礼包","20元增值券","30元礼包","10元增值券","88元礼包","5元增值券"];
    turnplate.colors = ["#FF9432",'#fff', "#FF9432","#fff", "#FF9432","#fff"];


    var rotateTimeOut = function (){
        $('#wheelcanvas').rotate({
            angle:0,
            animateTo:2160,
            duration:8000,
            callback:function (){
                alert('网络超时，请检查您的网络设置！');
            }
        });
    };

    //旋转转盘 item:奖品位置; txt：提示语;
    var rotateFn = function (item, txt){
        var angles = item * (360 / turnplate.restaraunts.length) - (360 / (turnplate.restaraunts.length*2));
        if(angles<270){
            angles = 270 - angles;
        }else{
            angles = 360 - angles + 270;
        }
        $('#wheelcanvas').stopRotate();
        $('#wheelcanvas').rotate({
            angle:0,
            animateTo:angles+1800,
            duration:7000,
            callback:function (){
                if(item==1){
                    $('.giftNum').text('50');
                    $('#ticket5').text('6');
                    $('#ticket10').text('2');
                }else if(item==3){
                    $('.giftNum').text('30');
                    $('#ticket5').text('4');
                    $('#ticket10').text('1');
                }
                $('#result').show();
                $('#shareBox').show();
                turnplate.bRotate = !turnplate.bRotate;
            }
        });
    };
    //抽奖
    $('.pointer').one('click',function (){
        if(turnplate.bRotate)return;
        turnplate.bRotate = !turnplate.bRotate;
        //获取随机数(奖品个数范围内)
        var item;
        item= rnd();
        rotateFn(item, turnplate.restaraunts[item-1]);
         android.result(getResult(item));//记录抽奖结果
    });
   //分享
    $('.share').on('click',function () {
            android.share();//分享再抽一次
    });
    //关闭弹窗
    $('.close-pop').on('click',function () {
        $('#result').hide();
        $('#resultBox').hide();
        $('#shareBox').hide();
    });
    //活动规则
    $('.activity').on('click',function () {
        layer.open({title:'活动规则',type: 1,skin: 'layui-layer-rim',area: ['75%', '55%'],content:$('#rule')});
    });
     $('.show').on('click',function () {
       android.check();//查看优惠券
     })
});
function showShareSuccess(){
     $('#result').show();
     $('#resultBox').show();
     $('#shareBox').hide();
}
//获奖概率
function rnd(){
    var ran=Math.floor(Math.random()*100);
    if(ran>=0&&ran<80){//30元礼包
        ran=3;
    }else if(ran>=80&&ran<100){//50元礼包
        ran=1;
    }
    return ran;
}

function getResult(num){
    if(num==1){//50元
        return 8;
    }else if(num==3){//30元
        return 7;
    }
}


//页面所有元素加载完毕后执行drawRouletteWheel()方法对转盘进行渲染
window.onload=function(){
    drawRouletteWheel();
};

function drawRouletteWheel() {
    var canvas = document.getElementById("wheelcanvas");
    if (canvas.getContext) {
        //根据奖品个数计算圆周角度
        var arc = Math.PI / (turnplate.restaraunts.length/2);
        var ctx = canvas.getContext("2d");
        //在给定矩形内清空一个矩形
        ctx.clearRect(0,0,422,422);
        //strokeStyle 属性设置或返回用于笔触的颜色、渐变或模式
        ctx.strokeStyle = "#fbdb00";
        //fonts 属性设置或返回画布上文本内容的当前字体属性
        ctx.font = '18px Microsoft YaHei';
        for(var i = 0; i < turnplate.restaraunts.length; i++) {
            var angle = turnplate.startAngle + i * arc;
            ctx.fillStyle = turnplate.colors[i];
            ctx.beginPath();
            //arc(x,y,r,起始角,结束角,绘制方向) 方法创建弧/曲线（用于创建圆或部分圆）
            ctx.arc(211, 211, turnplate.outsideRadius, angle, angle + arc, false);
            ctx.arc(211, 211, turnplate.insideRadius, angle + arc, angle, true);
            ctx.fill();
            //锁画布(为了保存之前的画布状态)
            ctx.save();
            //----绘制奖品开始----
            ctx.fillStyle = "rgba(227,0,0,0)";
            var text = turnplate.restaraunts[i];
            var line_height = 20;
            //translate方法重新映射画布上的 (0,0) 位置
            ctx.translate(211 + Math.cos(angle + arc / 2) * turnplate.textRadius, 211 + Math.sin(angle + arc / 2) * turnplate.textRadius);

            //rotate方法旋转当前的绘图
            ctx.rotate(angle + arc / 2 + Math.PI / 2);

            /** 下面代码根据奖品类型、奖品名称长度渲染不同效果，如字体、颜色、图片效果。(具体根据实际情况改变) **/
            if(text.indexOf("E")>0||text.indexOf("16")>0){
                var texts = text.split("M");
                for(var j = 0; j<texts.length; j++){
                    ctx.font = j == 0?'18px Microsoft YaHei':'16px Microsoft YaHei';
                    if(j == 0){
                        ctx.fillText(texts[j], -ctx.measureText(texts[j]).width / 2, j * line_height);
                    }else{
                        ctx.fillText(texts[j], -ctx.measureText(texts[j]).width / 2, j * line_height);
                    }
                }
            }else{
                //在画布上绘制填色的文本。文本的默认颜色是黑色
                //measureText()方法返回包含一个对象，该对象包含以像素计的指定字体宽度
                ctx.fillText(text, -ctx.measureText(text).width / 2, 0);
            }
            //添加对应图标
            if(text=="50元礼包"){
                var img= document.getElementById("img0");
                img.onload=function(){
                    ctx.drawImage(img,-30,0);
                };
                ctx.drawImage(img,-30,0);
            }else if(text=="20元增值券"){
                var img= document.getElementById("img1");
                img.onload=function(){
                    ctx.drawImage(img,-35,0);
                };
                ctx.drawImage(img,-35,0);
            }else if(text=="30元礼包"){
                var img= document.getElementById("img2");
                img.onload=function(){
                    ctx.drawImage(img,-30,0);
                };
                ctx.drawImage(img,-30,0);
            }else if(text=="10元增值券"){
                var img= document.getElementById("img3");
                img.onload=function(){
                    ctx.drawImage(img,-35,0);
                };
                ctx.drawImage(img,-35,0);
            }else if(text=="88元礼包"){
                var img= document.getElementById("img4");
                img.onload=function(){
                    ctx.drawImage(img,-30,10);
                };
                ctx.drawImage(img,-30,0);
            }else if(text=="5元增值券"){
                var img= document.getElementById("img5");
                img.onload=function(){
                    ctx.drawImage(img,-35,0);
                };
                ctx.drawImage(img,-35,0);
            }
            //把当前画布返回（调整）到上一个save()状态之前
            ctx.restore();
            //----绘制奖品结束----
        }
    }
}
